﻿
#include <windows.h>
#include <crtdbg.h>
#include <stdio.h>
#include <stdlib.h>

typedef unsigned char byte;
typedef unsigned int dword;

#define UND 0  // □ 
#define SEA 1  // ～ 
#define BSB 2  // ■
#define BSC 3  // ● ... Stage::Prepare()でBSAに置換
#define BSD 4  // ▲ ... Stage::Prepare()でBSAに置換
#define BSU 5  // ▲ ... Stage::Prepare()でBSAに置換
#define BSL 6  // ▲ ... Stage::Prepare()でBSAに置換
#define BSR 7  // ▲ ... Stage::Prepare()でBSAに置換
#define BSA 9  // ◆
#define PER 10

#define MAX_BOAT_SIZE 5
#define MAX_BOARD_SIZE 15
#define MAX_COUNT 6

// #define USE_BASE64_FORMAT
// #define DUMP_PROBLEM

#include "debug.h"
#include "rand.h"
#include "stage.h"
#include "solve.h"
#include "problem.h"

/*
●（最初のみ）
　～～～
　～●～
　～～～

▲（最初のみ）
　　　　～～～
　▲　→～▲～
　　　　～◆～
　　　　～　～

ヒント＝□＋◆　→　□は◆
ヒント＝◆　→　□は～

■に～が隣接、設置可能数（ヒント－◆）が2以下
　～　　～～～～～
　■　→　■■■
　　　　～～～～～

◆
　　　　～　～
　◆　→　◆　
　　　　～　～

□or◆の連続領域
　設置可能数：ヒント－両端確定済みの◆の数
　
　未設置BSの長さの最長　≦　連続数
　

未設置BSの長さ：
　最長　≦　□or◆の連続数の最大値
　最長　≦　ヒント－両端確定済みの◆の最大値
　→長さが一定値以上の未設置BSの数　＝　長さが一定値以上の盤面の最長の数のときは
　　一定値以上の長さが確定

□or◆の連続領域の最小値：
　注目する□or◆の連続領域以外の

*/
