
class Solve
{
public:
	Solve()
	{
		memset(count, 0, sizeof(count));
	}
	
	int * GetCount()
	{
		return count;
	}
	
	bool Process(Stage &stage, bool dump);
	bool Process(Stage &stage, int loop, bool dump);
	char GetDifficulty();

private:
	int count[MAX_COUNT];
	
	bool ProcessLoop1(Stage &stage);
	bool ProcessLoop2(Stage &stage);
	bool ProcessLoop3(Stage &stage);
	bool ProcessLoop4(Stage &stage);
	bool ProcessLoop4(Stage &stage, int loop);
	
	bool TryOnce(Stage &stage, int *pos);
};

bool SolveProblem(StageInfo &info);

