
class Stage;

#ifdef DUMP_PROBLEM
  #define DumpStage(stage) DumpResult(stage)
  #define DumpProblem(stage, left) DumpResult2(stage, left)
  #define DumpProblem2(stage, left) DumpResult2(stage, left)
#else
  #define DumpStage(stage)
  #define DumpProblem(stage, left)
  #define DumpProblem2(stage, left) DumpResult2(stage, left)
#endif

void DumpResult(Stage &stage);
void DumpResult2(Stage &stage, int left);

// #define OUTPUT_TIMER
#ifdef OUTPUT_TIMER
  void PerfCounter(int num);
  void PerfTimerStart(int num);
  void PerfTimerEnd(int num);
  void PerfFinish();
#else
  #define PerfCounter(num)
  #define PerfTimerStart(num)
  #define PerfTimerEnd(num)
  #define PerfFinish()
#endif
