
class Problem
{
public:
	Problem()
	{
		answer = NULL;
		stage = NULL;
	}
	
	~Problem()
	{
		delete answer;
		delete stage;
	}
	
	void Initialize(Rand &rand_, char width_, char height_);
	void Create(StageInfo &info);

private:
	char width;
	char height;
	Stage *answer;
	Stage *stage;
	Rand *rand;
	
	void Reset();
	void SetBlock(int num);
	void SearchOrphan();
	void SetLight(int num);
	void SearchAisle();
	bool SetHint();
	void RemoveHint(int *ratio);
	bool GetProblem(StageInfo &info);
};

void CreateProblem(Rand &rand, char width, char height, StageInfo &info);

