
class Problem
{
public:
	Problem() : answer(NULL){}
	
	~Problem()
	{
		delete[] answer;
	}
	
	void Initialize(Rand &rand, int width, int height);
	void Create();
	
	char * GetAnswer(){ return answer; }
	bool GetProblem(int x, int y){ return problem.Get(x, y); }

private:
	BinaryBoard problem;
	BinaryBoard rproblem;
	char *answer;
	int width;
	int height;
	Rand *rand;
	
	void CreateConnection(BinaryBoard &board, int x, int y0, int y1);
	void CreateBlock(BinaryBoard &board, int x0, int x1, int y0, int y1);
	void RotateBlock(BinaryBoard &src, BinaryBoard &dest, int x0, int x1, 
		int y0, int y1);
	void CheckZero(BinaryBoard &board, int x, int y, int pos);
	void CreateLine(BinaryBoard &board, int x, int y0, int y1);
};

bool CreateProblem(Rand &rand, int width, int height, char *result, 
	int *difficulty);

