
#include "battleship_creator.h"

static const char *DISP[] = {
	"@", "`", "", "", "",
	"", "", "", "", "",
};

void DumpResult(Stage &stage)
{
	printf("  ");
	for(int x = 1; x < stage.width - 1; x++){
		char hint = stage.hint[x - 1];
		printf(" %c", (hint >= 10) ? 'A' + hint - 10 : '0' + hint);
	}
	printf("\n");
	
	for(int y = 1; y < stage.height - 1; y++){
		char hint = stage.hint[stage.width + y - 3];
		printf("%c ", (hint >= 10) ? 'A' + hint - 10 : '0' + hint);
		
		for(int x = 1; x < stage.width - 1; x++){
			char status = stage.status[y * stage.width + x];
			printf("%s", DISP[status]);
		}
		printf("\n");
	}
	printf("\n");
}

