
class Rand
{
public:
	Rand()
	{
		InitializeCriticalSection(&cs);
		val = GetTickCount();
//		val = 4;
	}
	
	~Rand()
	{
		DeleteCriticalSection(&cs);
	}
	
	int Next()
	{
		EnterCriticalSection(&cs);
		val = (val * 1103515245 + 12345) & 2147483647;
		LeaveCriticalSection(&cs);
		
		return val;
	}
	
	int Next(int upper)
	{
		double temp = ((double)Next() + 1.0) / (2147483647.0 + 2.0);
		return (int)(temp * upper);
	}

private:
	int val;
	CRITICAL_SECTION cs;
};

