
class Solve
{
public:
	Solve()
	{
		memset(tryCount, 0, sizeof(tryCount));
		memset(tryCount2, 0, sizeof(tryCount2));
		loopCount = 0;
	}
	
	int GetLoopCount()
	{
		return loopCount;
	}
	
	int * GetTryCount()
	{
		return tryCount;
	}
	
	int * GetTryCount2()
	{
		return tryCount2;
	}
	
	bool Process(Stage &stage, bool dump);
	bool ProcessFast(Stage &stage);
	bool ProcessSimple(Stage &stage);
	char GetDifficulty();

private:
	int tryCount[6];
	int loopCount;
	int tryCount2[5];
	
	bool ProcessLoop(Stage &stage);
	bool ProcessSubloop(Stage &stage, int count);
	bool TryOnce(Stage &stage, bool find_cross, int count);
	bool TryTwice(Stage &stage, int count);
};

bool SolveProblem(StageInfo &info);

