
class ProblemHint
{
public:
	ProblemHint() : hint(NULL), poses(NULL){}
	
	~ProblemHint()
	{
		delete[] hint;
		delete[] poses;
	}
	
	void Initialize(Rand &rand, int width, int height);
	void Create(char *answer);
	bool Add(char *answer, Solve &solve, Solve &subsolve, Loop &loop, 
		int loopSize, int firstColor);
	void Remove(char *answer, Solve &solve, Loop &loop);
	void AdditionalAdd(char *answer, int minHint);
	
	char * GetHint(){ return hint; }
	int GetCount(){ return count; }

private:
	Rand *rand;
	char *hint;
	int *poses;
	BinaryBoard zero;
	int width;
	int height;
	int count;
};
